package com.example.plugin;

import org.zeroturnaround.javarebel.ClassResourceSource;
import org.zeroturnaround.javarebel.Integration;
import org.zeroturnaround.javarebel.IntegrationFactory;
import org.zeroturnaround.javarebel.Plugin;

public class SamplePlugin implements Plugin {

  @Override
  public void preinit() {
    Integration integration = IntegrationFactory.getInstance();
    ClassLoader cl = getClass().getClassLoader();

    integration.addIntegrationProcessor(cl,
        "my.package.MyClass",
        new MyClassCBP());

    // add more processors here
  }

  @Override
  public boolean checkDependencies(ClassLoader cl, ClassResourceSource crs) {
    // check if plugin should be enabled in classloader cl
    return crs.getClassResource("my.package.MyClass") != null;
  }

  @Override
  public String getId() {
    return "sample";
  }

  @Override
  public String getName() {
    return null;
  }

  @Override
  public String getDescription() {
    return null;
  }

  @Override
  public String getAuthor() {
    return null;
  }

  @Override
  public String getWebsite() {
    return null;
  }

  @Override
  public String getSupportedVersions() {
    return null;
  }

  @Override
  public String getTestedVersions() {
    return null;
  }
}
